#include "toglimg.h"

void toglInitImage(TOGLimage *img)
{
	if (!img) {
		return;
	}

	img->m_width = 0;
	img->m_height = 0;
	img->m_components = 3;

	img->m_buffer = NULL;
}

GLboolean toglAllocImage(TOGLimage *img)
{
	if (!img) {
		return GL_FALSE;
	}

	if (img->m_buffer) {
		free(img->m_buffer);
		img->m_buffer = NULL;
	}

	if (img->m_width <= 0 || img->m_height <= 0) {
		return GL_FALSE;
	}

	if ((img->m_buffer = 
	(unsigned char *)calloc(img->m_width * img->m_height * 4, sizeof(unsigned char))) == NULL) {
		return GL_FALSE;
	}
	else {
		return GL_TRUE;
	}
}

void toglDeleteImage(TOGLimage *img)
{
	if (!img) {
		return;
	}
	
	if (img->m_buffer) {
		free(img->m_buffer);
		img->m_buffer = NULL;
	}
}

/*
 *   Endian
 */
void toglChangeEndiansv(GLshort *data)
{
	toglChangeEndianusv((GLushort *)data);
}

void toglChangeEndianiv(GLint *data)
{
	toglChangeEndianuiv((GLuint *)data);
}

void toglChangeEndianusv(GLushort *data)
{
	unsigned char	*p, c;

	p = (unsigned char *)data;

	c = p[0];
	p[0] = p[1];
	p[1] = c;
}

void toglChangeEndianuiv(GLuint *data)
{
	unsigned char	*p, c[2];

	p = (unsigned char *)data;

	c[0] = p[0];
	c[1] = p[1];
	p[0] = p[3];
	p[1] = p[2];
	p[2] = c[1];
	p[3] = c[0];
}

/*
 *   Extension
 *
 */
GLboolean toglCheckExtension(char filename[], char *Ext)
{
	char		*p = filename;
	int			lf, le;
	int			i;
	GLboolean	stat;


	if (Ext == NULL || filename == NULL) {
		return GL_FALSE;
	}

	lf = (int)strlen(filename);
	le = (int)strlen(Ext);

	if (lf == 0 || le == 0) {
		return GL_FALSE;
	}

	stat = GL_TRUE;
	for(i = 0; i < le; i++) {
		if (tolower(p[lf - i - 1]) != tolower(Ext[le - i - 1])) {
			stat = GL_FALSE;
			break;
		}
	}

	return stat;
}
